/* --------------------------------------------------------
   {bgړ铹𓾂邽߂̃vO

                                     2003/10/20
                                         S.Mio
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* -------------------------------------------------------- */
#define MAP_WIDTH  15   /* }bṽTCY */
#define MAP_HEIGHT 5

#define ROBO_XPOS  0    /* {bg̈ʒu */
#define ROBO_YPOS  2

#define GOAL_XPOS  14   /* S[̈ʒu */
#define GOAL_YPOS  2

#define ATTR_EMPTY  0   /* }bv1}XԂ̓e */
#define ATTR_SEARCH 1
#define ATTR_CLOSE  2
#define ATTR_WALL   3
#define ATTR_GOAL   4
#define ATTR_START  5
#define ATTR_PATH   6


/* -------------------------------------------------------- */
/* x, y 2_Ԃ\ */
typedef struct {
  int x, y;
} t_point;

/* m[h */
typedef struct {
  t_point pos;      /* ̏ꏊ                 */
  t_point backpos;  /* Tn߂ꏊ           */
  int cost;         /* ݈ʒũRXg           */
  int attr;         /* ̒n_Tς݂ǂ */
} t_node;

/* }bvŜmapfieldz */
t_node mapfield[MAP_WIDTH][MAP_HEIGHT];

/* Tn_W߂obt@ */
#define SEARCHQUE_LIMIT  50
t_node *searchque[SEARCHQUE_LIMIT];
int searchque_head;


/* -------------------------------------------------------- */
/* }bv̏ */
void map_init(void)
{
    int i, x, y;

    memset(mapfield, 0, sizeof(mapfield));
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            mapfield[x][y].pos.x = x;
            mapfield[x][y].pos.y = y;
        }
    }
    
    /* Q̐ݒ */
    for (i = 0; i < 4; i++) {
        mapfield[10][i].attr = ATTR_WALL;
        mapfield[4][(MAP_HEIGHT - 1) - i].attr = ATTR_WALL;
    }
}


/* -------------------------------------------------------- */
/* 2_Ԃ̋𑪂 */
int distance(t_point *pos1, t_point *pos2)
{
    int dx, dy, d;

    dx = abs(pos1->x - pos2->x);
    dy = abs(pos1->y - pos2->y);

    d = ((dx < dy) ? dx : dy) / 2;
    return  dx + dy - d;
}

/* RXgv */
int poscost(t_point *pos, t_point *checkpos)
{
    int cost;

    /* 2_Ԃ̋̂܂܃RXg */
    cost = distance(pos, checkpos);
    return cost;
}


/* -------------------------------------------------------- */
/* L[ɒTǉ */
void que_push(t_node *node)
{
    t_node *tmpnode;
    int i, j;

    if (searchque_head >= SEARCHQUE_LIMIT)
        return;
    searchque[searchque_head] = node;
    searchque_head++;

    /* RXg̒ႢŃ\[gĂ */
    if (searchque_head <= 1)
        return;
    for (i = 0; i < searchque_head; i++) {
        for (j = 1; j < searchque_head - i; j++) {
            if (searchque[j - 1]->cost < searchque[j]->cost) {
                tmpnode = searchque[j - 1];
                searchque[j - 1] = searchque[j];
                searchque[j] = tmpnode;
            }
        }
    }
}

/* L[To  */
t_node *que_pop(void)
{
    if (searchque_head == 0)
        return NULL;
    searchque_head--;
    return searchque[searchque_head];
}


/* -------------------------------------------------------- */
/* TꂽpXǂ */
void path_check(int goalx, int goaly)
{
    int x, y, nextx, nexty;
    
    nextx = mapfield[goalx][goaly].backpos.x;
    nexty = mapfield[goalx][goaly].backpos.y;
    do {
        x = nextx;
        y = nexty;
        mapfield[x][y].attr = ATTR_PATH;
        nextx = mapfield[x][y].backpos.x;
        nexty = mapfield[x][y].backpos.y;
    } while(mapfield[nextx][nexty].attr != ATTR_START);
}


/* -------------------------------------------------------- */
/* T{ */
void root_search(int startx, int starty, int goalx, int goaly)
{
    /* 8𒲂ׂ邽߂̑΍W */
    t_point difpos[] = {{-1, -1}, {0, -1}, {1, -1},
                        {-1,  0}, {1, 0},
                        {-1,  1}, {0, 1},  {1,  1}};
    int i, checkx, checky, cost, checkcount;
    t_node *nowpos;
    searchque_head = 0;
    
    /* S[ƃX^[g̐ݒ */
    mapfield[startx][starty].attr = ATTR_START;
    mapfield[startx][starty].cost = 200;
    mapfield[goalx][goaly].attr = ATTR_GOAL;
    
    /* X^[gʒuL[ɓ */
    que_push(&mapfield[startx][starty]);
    
    /* checknodeS[ɍs܂Ń[v */
    do {
        /* ׂʒuL[o */
        nowpos = que_pop();
        if(nowpos == NULL) {
            printf("S[ɓBł܂B\n");
            return;
        }
        
        /* 8ׂ */
        checkcount = 0;
        for (i = 0; i < 8; i++) {
            checkx = nowpos->pos.x + difpos[i].x;
            checky = nowpos->pos.y + difpos[i].y;
            
            /* ͈̓`FbN */
            if ((checkx < 0) || (checkx >= MAP_WIDTH) || 
                (checky < 0) || (checky >= MAP_HEIGHT))
                continue;

            /* S[甲 */
            if (mapfield[checkx][checky].attr == ATTR_GOAL) {
                mapfield[checkx][checky].backpos.x = nowpos->pos.x;
                mapfield[checkx][checky].backpos.y = nowpos->pos.y;
                break;
            }

            /* ǂ⒲ς݂炻̈ʒu͎gȂ */
            if (mapfield[checkx][checky].attr != ATTR_EMPTY)
                continue;
            
            /* RXg𓾂 */
            cost = poscost(&mapfield[checkx][checky].pos, 
                           &mapfield[goalx][goaly].pos);
            
            /* RXgɒuĎ̒ */
            mapfield[checkx][checky].attr = ATTR_SEARCH;
            mapfield[checkx][checky].cost = cost;
            mapfield[checkx][checky].backpos.x = nowpos->pos.x;
            mapfield[checkx][checky].backpos.y = nowpos->pos.y;
            que_push(&mapfield[checkx][checky]);
            checkcount++;
        }
        /* 1͂𒲂ׂȂCセ̈ʒu͎gȂ */
        if ((!checkcount) && (nowpos->attr == ATTR_SEARCH))
            nowpos->attr = ATTR_CLOSE;
        if (nowpos->attr == ATTR_EMPTY)
            nowpos->attr = ATTR_SEARCH;
    } while(mapfield[checkx][checky].attr != ATTR_GOAL);
    path_check(goalx, goaly);
}


/* -------------------------------------------------------- */
/* oH̕\ */
void map_print(void)
{
    int x, y, dx, dy;
    unsigned short strbuf[MAP_WIDTH + 1];
    char buf[12];
    char headbuf[(MAP_WIDTH * 2) + 4];
    char *mapcharTable = {"D  ~f"};
    char *mapvectorTable[3][3] = {{"_","","^",},
                                  {"","  ","",},
                                  {"^","","_"}};

    memset(headbuf + 1, '-', MAP_WIDTH * 2);
    headbuf[(MAP_WIDTH * 2) + 1] = '+';
    headbuf[(MAP_WIDTH * 2) + 2] = '\n';
    headbuf[(MAP_WIDTH * 2) + 3] = '\0';
    headbuf[0] = '+';
    
    
    printf("T\n%s", headbuf);
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if (mapfield[x][y].attr == ATTR_SEARCH) {
                dx = (x - mapfield[x][y].backpos.x) + 1;
                dy = (y - mapfield[x][y].backpos.y) + 1;
                strbuf[x] = *(unsigned short *)mapvectorTable[dy][dx];
            } else {
                strbuf[x] = *(unsigned short *)(mapcharTable + (mapfield[x][y].attr * 2));
            }
        }
        strbuf[MAP_WIDTH] = '\0';
        printf("|%s|\n", strbuf);
    }
    printf(headbuf);

    printf("d\n%s", headbuf);
    for (y = 0; y < MAP_HEIGHT; y++) {
        for (x = 0; x < MAP_WIDTH; x++) {
            if ((mapfield[x][y].attr == ATTR_SEARCH) ||
                (mapfield[x][y].attr == ATTR_PATH)) {
                sprintf(buf, "%2d", mapfield[x][y].cost);
                strbuf[x] = *(unsigned short *)buf;
            } else if (mapfield[x][y].attr == ATTR_WALL) {
                strbuf[x] = *(unsigned short *)(mapcharTable + (mapfield[x][y].attr * 2));
            } else {
                strbuf[x] = *(unsigned short *)(mapcharTable + (ATTR_SEARCH * 2));
            }
        }
        strbuf[MAP_WIDTH] = '\0';
        printf("|%s|\n", strbuf);
    }
    printf(headbuf);
}


/* -------------------------------------------------------- */
int main(void)
{
    map_init();
    root_search(ROBO_XPOS, ROBO_YPOS, GOAL_XPOS, GOAL_YPOS);
    map_print();
    return 0;
}
